## mapnik 0.7.0

=== SConstruct ===
# This file is part of Mapnik (c++ mapping toolkit)
#
# Copyright (C) 2009 Artem Pavlenko, Jean-Francois Doyon, Dane Springmeyer
#
# Mapnik is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
# $Id: SConstruct 1539 2010-01-11 01:28:42Z dane $


import os
import sys
import re
import platform
from glob import glob
from subprocess import Popen, PIPE
from SCons.SConf import SetCacheMode
import pickle

try:
    import distutils.sysconfig
    HAS_DISTUTILS = True
except:
    HAS_DISTUTILS = False

#### SCons build options and initial setup ####
env = Environment(ENV=os.environ)

def color_print(color,text,newline=True):
    # 1 - red
    # 2 - green
    # 3 - yellow
    # 4 - blue
    text = "\033[9%sm%s\033[0m" % (color,text)
    if not newline:
        print text,
    else:
        print text

def regular_print(color,text,newline=True):
    if not newline:
        print text,
    else:
        print text

def call(cmd, silent=False):
    stdin, stderr = Popen(cmd,shell=True,stdout=PIPE,stderr=PIPE).communicate()
    if not stderr:
        return stdin.strip()
    elif not silent:
        color_print(1,'Problem encounted with SCons scripts, please post bug report to: http://trac.mapnik.org\nError was: %s' % stderr)

def shortest_name(libs):
    name = '-'*200
    for lib in libs:
        if len(name) > len(lib):
            name = lib
    return name

if platform.uname()[4] == 'x86_64' and platform.system() == 'Linux':
    LIBDIR_SCHEMA='lib64' 
elif platform.uname()[4] == 'ppc64':
    LIBDIR_SCHEMA='lib64'
else:
    LIBDIR_SCHEMA='lib'

pretty_dep_names = {
    'ociei':'Oracle database library | configure with OCCI_LIBS & OCCI_INCLUDES | more info: http://trac.mapnik.org/wiki/OCCI',
    'gdal':'GDAL C++ library | configured using gdal-config program | try setting GDAL_CONFIG SCons option | more info: http://trac.mapnik.org/wiki/GDAL',
    'ogr':'OGR-enabled GDAL C++ Library | configured using gdal-config program | try setting GDAL_CONFIG SCons option | more info: http://trac.mapnik.org/wiki/OGR',
    'cairo':'Cairo C library | configured using pkg-config | try setting PKG_CONFIG_PATH SCons option',
    'cairomm':'Cairomm C++ bindings to Cairo library | configured using pkg-config | try setting PKG_CONFIG_PATH SCons option',
    'pycairo':'Python bindings to Cairo library | configured using pkg-config | try setting PKG_CONFIG_PATH SCons option',
    'proj':'Proj.4 C Projections library | configure with PROJ_LIBS & PROJ_INCLUDES | more info: http://trac.osgeo.org/proj/',
    'pg':'Postgres C Library requiered for PostGIS plugin | configure with pg_config program | more info: http://trac.mapnik.org/wiki/PostGIS',
    'sqlite3':'SQLite3 C Library | configure with SQLITE_LIBS & SQLITE_INCLUDES | more info: http://trac.mapnik.org/wiki/SQLite',
    'osm':'more info: http://trac.mapnik.org/wiki/OsmPlugin',
    'jpeg':'JPEG C library | configure with JPEG_LIBS & JPEG_INCLUDES',
    'tiff':'TIFF C library | configure with TIFF_LIBS & TIFF_INCLUDES',
    'png':'PNG C library | configure with PNG_LIBS & PNG_INCLUDES',
    'icuuc':'ICU C++ library | configure with ICU_LIBS & ICU_INCLUDES or use ICU_LIB_NAME to specify custom lib name  | more info: http://site.icu-project.org/',
    'ltdl':'GNU Libtool | more info: http://www.gnu.org/software/libtool',
    'z':'Z compression library | more info: http://www.zlib.net/',
    'm':'Basic math library, part of C++ stlib',
    'pkg-config':'pkg-config tool | more info: http://pkg-config.freedesktop.org',
    'pg_config':'pg_config program | try setting PG_CONFIG SCons option',
    'xml2-config':'xml2-config program | try setting XML2_CONFIG SCons option',
    'gdal-config':'gdal-config program | try setting GDAL_CONFIG SCons option',
    'freetype-config':'freetype-config program | try setting FREETYPE_CONFIG SCons option',
    }
    
def pretty_dep(dep):
    pretty = pretty_dep_names.get(dep)
    if pretty:
        return '%s (%s)' % (dep,pretty)
    elif 'boost' in dep:
        return '%s (%s)' % (dep,'more info see: http://trac.mapnik.org/wiki/MapnikInstallation & http://www.boost.org')
    return dep

# local file to hold custom user configuration variables
SCONS_LOCAL_CONFIG = 'config.py'
# local pickled file to cache configured environment
SCONS_CONFIGURE_CACHE = 'config.cache'
# directory SCons uses to stash build tests
SCONF_TEMP_DIR = '.sconf_temp'
# auto-search directories for boost libs/headers
BOOST_SEARCH_PREFIXES = ['/usr/local','/opt/local','/sw','/usr',]


# Core plugin build configuration
# opts.AddVariables still hardcoded however...
PLUGINS = { # plugins with external dependencies
            'postgis': {'default':True,'path':'PGSQL','inc':'libpq-fe.h','lib':'pq','lang':'C'},
            'gdal':    {'default':False,'path':None,'inc':'gdal_priv.h','lib':'gdal','lang':'C++'},
            'ogr':     {'default':False,'path':None,'inc':'ogrsf_frmts.h','lib':'gdal','lang':'C++'},
            'occi':    {'default':False,'path':'OCCI','inc':'occi.h','lib':'ociei','lang':'C++'},
            'sqlite':  {'default':False,'path':'SQLITE','inc':'sqlite3.h','lib':'sqlite3','lang':'C'},
            
            # todo: osm plugin does depend on libxml2 and libcurl
            'osm':     {'default':False,'path':None,'inc':None,'lib':None,'lang':'C++'},

            # plugins without external dependencies requiring CheckLibWithHeader...
            'shape':   {'default':True,'path':None,'inc':None,'lib':None,'lang':'C++'},
            'raster':  {'default':True,'path':None,'inc':None,'lib':None,'lang':'C++'},
            'kismet':  {'default':False,'path':None,'inc':None,'lib':None,'lang':'C++'},
            }

DEFAULT_PLUGINS = []
for k,v in PLUGINS.items():
   if v['default']:
       DEFAULT_PLUGINS.append(k)

# All of the following options may be modified at the command-line, for example:
# `python scons/scons.py PREFIX=/opt`
opts = Variables()

opts.AddVariables(
    # Compiler options
    ('CXX', 'The C++ compiler to use (defaults to g++).', 'g++'),
    EnumVariable('OPTIMIZATION','Set g++ optimization level','2', ['0','1','2','3','4']),
    # Note: setting DEBUG=True will override any custom OPTIMIZATION level
    BoolVariable('DEBUG', 'Compile a debug version of Mapnik', 'False'),
    BoolVariable('XML_DEBUG', 'Compile a XML verbose debug version of mapnik', 'False'),
    ListVariable('INPUT_PLUGINS','Input drivers to include',DEFAULT_PLUGINS,PLUGINS.keys()),
    
    # SCons build behavior options
    ('CONFIG', "The path to the python file in which to save user configuration options. Currently : '%s'" % SCONS_LOCAL_CONFIG,SCONS_LOCAL_CONFIG),
    BoolVariable('USE_CONFIG', "Use SCons user '%s' file (will also write variables after successful configuration)", 'True'),
    BoolVariable('FAST', "Make scons faster at the cost of less precise dependency tracking", 'False'),
    
    # Install Variables
    ('PREFIX', 'The install path "prefix"', '/usr/local'),
    ('PYTHON_PREFIX','Custom install path "prefix" for python bindings (default of no prefix)',''),
    ('DESTDIR', 'The root directory to install into. Useful mainly for binary package building', '/'),
    
    # Boost variables
    # default is '/usr/include', see FindBoost method below
    ('BOOST_INCLUDES', 'Search path for boost include files', '',False),
    # default is '/usr/' + LIBDIR_SCHEMA, see FindBoost method below
    ('BOOST_LIBS', 'Search path for boost library files', '',False),
    ('BOOST_TOOLKIT','Specify boost toolkit, e.g., gcc41.','',False),
    ('BOOST_ABI', 'Specify boost ABI, e.g., d.','',False),
    ('BOOST_VERSION','Specify boost version, e.g., 1_35.','',False),
    ('BOOST_PYTHON_LIB','Specify library name or full path to boost_python lib (e.g. "boost_python-py26" or "/usr/lib/libboost_python.dylib")',''),
    
    # Variables for required dependencies
    ('FREETYPE_CONFIG', 'The path to the freetype-config executable.', 'freetype-config'),
    ('XML2_CONFIG', 'The path to the xml2-config executable.', 'xml2-config'),
    PathVariable('ICU_INCLUDES', 'Search path for ICU include files', '/usr/include', PathVariable.PathAccept),
    PathVariable('ICU_LIBS','Search path for ICU include files','/usr/' + LIBDIR_SCHEMA, PathVariable.PathAccept),
    ('ICU_LIB_NAME', 'The library name for icu (such as icuuc, sicuuc, or icucore)', 'icuuc'),
    PathVariable('PNG_INCLUDES', 'Search path for libpng include files', '/usr/include', PathVariable.PathAccept),
    PathVariable('PNG_LIBS','Search path for libpng include files','/usr/' + LIBDIR_SCHEMA, PathVariable.PathAccept),
    PathVariable('JPEG_INCLUDES', 'Search path for libjpeg include files', '/usr/include', PathVariable.PathAccept),
    PathVariable('JPEG_LIBS', 'Search path for libjpeg library files', '/usr/' + LIBDIR_SCHEMA, PathVariable.PathAccept),
    PathVariable('TIFF_INCLUDES', 'Search path for libtiff include files', '/usr/include', PathVariable.PathAccept),
    PathVariable('TIFF_LIBS', 'Search path for libtiff library files', '/usr/' + LIBDIR_SCHEMA, PathVariable.PathAccept),
    PathVariable('PROJ_INCLUDES', 'Search path for PROJ.4 include files', '/usr/local/include', PathVariable.PathAccept),
    PathVariable('PROJ_LIBS', 'Search path for PROJ.4 library files', '/usr/local/' + LIBDIR_SCHEMA, PathVariable.PathAccept),
    ('PKG_CONFIG_PATH', 'Use this path to point pkg-config to .pc files instead of the PKG_CONFIG_PATH environment setting',''),
    
    # Variables affecting rendering back-ends
    BoolVariable('INTERNAL_LIBAGG', 'Use provided libagg', 'True'),
    
    # Variables for optional dependencies
    # Note: cairo, cairomm, and pycairo all optional but configured automatically through pkg-config
    # Therefore, we use a single boolean for whether to attempt to build cairo support.
    BoolVariable('CAIRO', 'Attempt to build with Cairo rendering support', 'True'),
    ('GDAL_CONFIG', 'The path to the gdal-config executable for finding gdal and ogr details.', 'gdal-config'),
    ('PG_CONFIG', 'The path to the pg_config executable.', 'pg_config'),
    PathVariable('OCCI_INCLUDES', 'Search path for OCCI include files', '/usr/lib/oracle/10.2.0.3/client/include', PathVariable.PathAccept),
    PathVariable('OCCI_LIBS', 'Search path for OCCI library files', '/usr/lib/oracle/10.2.0.3/client/'+ LIBDIR_SCHEMA, PathVariable.PathAccept),
    PathVariable('SQLITE_INCLUDES', 'Search path for SQLITE include files', '/usr/include/', PathVariable.PathAccept),
    PathVariable('SQLITE_LIBS', 'Search path for SQLITE library files', '/usr/' + LIBDIR_SCHEMA, PathVariable.PathAccept),
    
    # Other variables
    BoolVariable('SHAPE_MEMORY_MAPPED_FILE', 'Utilize memory-mapped files in Shapefile Plugin (higher memory usage, better performance)', 'True'),
    ('SYSTEM_FONTS','Provide location for python bindings to register fonts (if given aborts installation of bundled DejaVu fonts)',''),
    ('LIB_DIR_NAME','Name to use for the "lib" folder where fonts and plugins are installed','/mapnik/'),
    PathVariable('PYTHON','Full path to Python executable used to build bindings', sys.executable),
    BoolVariable('FRAMEWORK_PYTHON', 'Link against Framework Python on Mac OS X', 'True'),
    ('FRAMEWORK_SEARCH_PATH','Custom framework search path on Mac OS X', ''),

=== demo/c++/Makefile ===
CXX = g++

INCLUDE = `pkg-config --cflags mapnik freetype2 cairomm-1.0`
LIBDIR  = `pkg-config --libs mapnik freetype2 cairomm-1.0`

DEFINES = 

CXXFLAGS = $(DEFINES) $(INCLUDE) -Wall

LIBS =  $(LIBDIR)

OBJ = rundemo.o

BIN = rundemo

all : $(BIN)

$(BIN) : $(OBJ)
	libtool $(CXX) $(OBJ) $(LIBS) -o $@

.c.o :
	$(CXX) -c $(CXXFLAGS) $<

.PHONY : clean

clean: 
	rm -f $(OBJ)
	rm -f $(BIN)

=== debian/changelog ===
mapnik (0.7.0-2ubuntu1) lucid; urgency=low

  * Merge from debian testing (LP: #526070), remaining changes:
    - Bump boost build-dep and libmapnik-dev depends to boost1.40

 -- Christophe Sauthier <christophe.sauthier@objectif-libre.com>  Thu, 18 Mar 2010 01:07:40 +0100

mapnik (0.7.0-2) unstable; urgency=low

  * Fix various FTBFS (Closes: #570865)
  * debian/patches/:
    - 00-fix_amd64_libdir.patch added, install the shared library
      in /usr/lib/ also on amd64.
  * debian/rules:
    - pass -r to xargs when fixing permissions, thanks to KiBi
    - ignore errors during doc generation

 -- David Paleino <dapal@debian.org>  Fri, 26 Feb 2010 23:04:32 +0100

mapnik (0.7.0-1) unstable; urgency=low

  [ Dominic Hargreaves ]
  * Change Maintainer to Debian GIS Project (Closes: #551281)
  * Add Vcs-Git and Vcs-Browser fields to reflect move to a
    public repository

  [ David Paleino ]
  * New upstream release (Closes: #567007)
  * Package converted to 3.0 (quilt) format
  * debian/control:
    - added myself to Uploaders
    - added Debian OSM Team to Uploaders
    - wrapped dependency fields (eases reading diffs in commits)
    - remove duplicate Section in libmapnik0.6
    - Standards-Version bumped to 3.8.4, no changes needed
    - fix Build-Dependencies:
      + bump debhelper version
      + use python-support instead of python-central
      + drop useless dependency on python
      + added scons build-dependency, don't use the embedded one
    - support Python >= 2.5
    - libmapnik0.6 → libmapnik0.7 because of SONAME bump
    - added ${misc:Depends} where missing
  * debian/watch updated to use new url
  * debian/rules:
    - added quilt infrastructure
    - rewritten to use dh7
    - handle multiple Python versions
  * debian/patches/:
    - 01-generate_local_docs.patch added, tell epydoc to generate
      docs from local code, don't look for a system-wide module.
    - 02-fix_FTBFS_binutils-gold.patch added (Closes: #555586)
    - 03-fix_typo.patch added
  * debian/copyright, substitute (C) with © to make lintian happy
  * debian/mapnik-doc.doc-base added
  * debian/libmapnik-dev.dirs added
  * debian/*.1 moved to debian/manpages/
  * debian/compat bumped to 7
  * debian/copyright updated to be DEP-5-compliant

 -- David Paleino <dapal@debian.org>  Sun, 21 Feb 2010 10:30:54 +0100

mapnik (0.6.1-1) unstable; urgency=low

  * New upstream release (closes: #537802, #545887)
  * Add dependency on python-cairo to python-mapnik (closes: #538862)
  * Enable build of kismet plugin
  * Update Standards-Version (no changes)
  * Apply patch from mapnik trunk to fix linking against agg
  * Apply changeset 1340 from mapnik trunk to fix shapefile compiler
    options
  * Switch to unversioned boost
  * Bump Standards-Version (no changes)
  * Adjust versioned dep libmapnik-dev -> libmapnik0.6
  * Change libmapnik-dev from Architecture: all to any to satisfy
    strict versioned dependency requirements
  * Split out API docs and examples into a separate package to avoid
    archive bloat due to above

 -- Dominic Hargreaves <dom@earth.li>  Mon, 19 Oct 2009 23:28:32 +0100

mapnik (0.6.1-0ubuntu5) lucid; urgency=low

  * Bump boost build-dep and libmapnik-dev depends to boost1.40
    - Libicu transition gets done as an added bonus
  * Add debian/patches/find_python_boost.patch to work with boost 1.39 and
    later
    - Patch from upstream http://trac.mapnik.org/changeset/1279

 -- Scott Kitterman <scott@kitterman.com>  Thu, 14 Jan 2010 15:15:25 -0500

mapnik (0.6.1-0ubuntu4) karmic; urgency=low

  * debian/patches/fix_shapefile_issue.patch:
    Fix the shapefile reading issue that was raised by upstream

 -- Christophe Sauthier <christophe.sauthier@objectif-libre.com>  Sat, 17 Oct 2009 00:07:52 +0200

mapnik (0.6.1-0ubuntu3) karmic; urgency=low

  * Revert changes to use /usr/lib64; libraries are not supposed to be
    installed to this directory (which is a symlink to /usr/lib), and the
    debian/mapnik-plugin-base change makes the script unusable on amd64.
  * debian/patches/proper_amd64_lib_dir.patch: ensure files are installed
    to /usr/lib on amd64.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 12 Oct 2009 09:21:34 +0000

mapnik (0.6.1-0ubuntu2) karmic; urgency=low

  * Fix the libagg issue.
    - add quilt as a build dependency
    - debian/rules modified to include quilt
    - addition of debian/patches/01_fix_libagg_name.diff

 -- Christophe Sauthier <christophe.sauthier@objectif-libre.com>  Sat, 29 Aug 2009 14:47:44 +0200

mapnik (0.6.1-0ubuntu1) karmic; urgency=low

  * New upstream release.
  * Change usr/lib to usr/lib* to enable build on 64 bits systems due to new
    configuration in SConstruct in :
    - debian/libmapnik-dev.install
    - debian/libmapnik0.6.install
    - debian/mapnik-plugin-base

 -- Christophe Sauthier <christophe.sauthier@objectif-libre.com>  Fri, 28 Aug 2009 01:34:41 +0200

mapnik (0.6.0-1ubuntu1) karmic; urgency=low

  * Merge from debian unstable (LP: #378819), remaining changes:
    - debian/control:
      + Change bdeps from python2.5-dev to python-all-dev (>= 2.5)
      + Change XS-Python-Version from 2.5 to >= 2.5
    - debian/rules:
      + Various changes to enable python2.5 and python2.6 builds
  * debian/patches/libtool2_2.diff Dropped. Included upsteam.
  * Removed quilt support.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 20 May 2009 15:39:58 -0500

mapnik (0.6.0-1) unstable; urgency=low

  * New upstream release (closes: #522823, #523190)
  * Update debian/build-svn-tarball.sh for next major release
  * Update build-dep from proj to libproj-dev to reflect proj package
    reorganization (closes: #521818)
  * Add explicit configure step in debian/rules
  * Update Standards-Version (no changes)
  * Update build-dep from libltdl3-dev to libltdl-dev to reflect libtool
    changes
  * Changes from Ubuntu:
    - add Homepage control field
    - update python-mapnik install file to be compatible with Python 2.6
      transition


=== debian/control ===
Source: mapnik
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Debian OpenStreetMap Team <pkg-osm-maint@lists.alioth.debian.org>,
 David Paleino <dapal@debian.org>
Build-Depends:
 scons,
 python-support (>= 0.90.0~),
 debhelper (>= 7.0.50~),
 python-all-dev,
 libboost-thread1.40-dev,
 libboost-filesystem1.40-dev,
 libboost-regex1.40-dev,
 libboost-python1.40-dev,
 libboost-system1.40-dev,
 libboost-iostreams1.40-dev,
 libboost-program-options1.40-dev,
 libpng12-dev,
 libjpeg62-dev,
 libtiff4-dev,
 zlib1g-dev,
 libfreetype6-dev,
 libpq-dev,
 libproj-dev,
 libltdl-dev,
 libfribidi-dev,
 libgdal1-dev,
 libxml2-dev,
 libagg-dev,
 libicu-dev,
 libcairo2-dev,
 libcairomm-1.0-dev,
 python-cairo-dev,
 libsqlite3-dev,
 libcurl4-gnutls-dev,
 libsigc++-2.0-dev,
 python-epydoc
Standards-Version: 3.8.4
Section: libs
XS-Python-Version: >= 2.5
Homepage: http://www.mapnik.org/
Vcs-Git: git://git.debian.org/pkg-grass/mapnik.git
Vcs-Browser: http://git.debian.org/?p=pkg-grass/mapnik.git

Package: libmapnik0.7
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ttf-dejavu
Suggests: postgis
Description: C++/Python toolkit for developing GIS applications (libraries)
 Mapnik is an OpenSource C++/Python toolkit for developing GIS
 (Geographic Information Systems) applications. At the core is a C++
 shared library providing algorithms/patterns for spatial data access and
 visualization.
 .
 Essentially a collection of geographic objects (map, layer, datasource,
 feature, geometry), the library doesn't rely on "windowing systems" and
 is intended to work in multi-threaded environments
 .
 High-level Python bindings (boost.python) facilitate rapid application
 development, targeting zope3, django, etc.
 .
 This package contains the shared library and input plugins.

Package: libmapnik-dev
Section: libdevel
Architecture: any
Depends:
 ${misc:Depends},
 libmapnik0.7 (= ${binary:Version}),
 libc6-dev | libc-dev,
 libboost-thread1.40-dev,
 libboost-filesystem1.40-dev,
 libboost-regex1.40-dev,
 libboost-python1.40-dev,
 libboost-system1.40-dev,
 libboost-iostreams1.40-dev,
 libpng12-dev,
 libjpeg62-dev,
 libtiff4-dev,
 zlib1g-dev,
 libfreetype6-dev,
 libpq-dev,
 libproj-dev,
 libltdl-dev,
 libfribidi-dev,
 libgdal1-dev,
 libxml2-dev,
 libagg-dev,
 libicu-dev,
 libcairo2-dev,
 libcairomm-1.0-dev,
 python-cairo-dev,
 libsqlite3-dev,
 libcurl4-gnutls-dev,
 libsigc++-2.0-dev
Recommends: mapnik-doc
Description: C++/Python toolkit for developing GIS applications (devel)
 Mapnik is an OpenSource C++/Python toolkit for developing GIS
 (Geographic Information Systems) applications. At the core is a C++
 shared library providing algorithms/patterns for spatial data access and
 visualization.
 .
 Essentially a collection of geographic objects (map, layer, datasource,
 feature, geometry), the library doesn't rely on "windowing systems" and
 is intended to work in multi-threaded environments
 .
 High-level Python bindings (boost.python) facilitate rapid application
 development, targeting zope3, django, etc.
 .
 This package contains the development headers, API documentation, and
 build utilities.

Package: mapnik-utils
Section: utils
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: C++/Python toolkit for developing GIS applications (utilities)
 Mapnik is an OpenSource C++/Python toolkit for developing GIS
 (Geographic Information Systems) applications. At the core is a C++
 shared library providing algorithms/patterns for spatial data access and
 visualization.
 .
 Essentially a collection of geographic objects (map, layer, datasource,
 feature, geometry), the library doesn't rely on "windowing systems" and
 is intended to work in multi-threaded environments
 .
 High-level Python bindings (boost.python) facilitate rapid application
 development, targeting zope3, django, etc.
 .
 This package contains miscellaneous utilities distributed with mapnik:
 .
 shapeindex: program to creates file system based index for ESRI shape-files

Package: python-mapnik
Section: python
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${python:Depends},
 python-cairo
Provides: ${python:Provides}
XB-Python-Version: ${python:Versions}
Description: C++/Python toolkit for developing GIS applications (Python)
 Mapnik is an OpenSource C++/Python toolkit for developing GIS
 (Geographic Information Systems) applications. At the core is a C++
 shared library providing algorithms/patterns for spatial data access and
 visualization.
 .
 Essentially a collection of geographic objects (map, layer, datasource,
 feature, geometry), the library doesn't rely on "windowing systems" and
 is intended to work in multi-threaded environments
 .
 High-level Python bindings (boost.python) facilitate rapid application
 development, targeting zope3, django, etc.
 .
 This package contains the Python bindings.

Package: mapnik-doc
Section: doc
Architecture: all
Recommends: libmapnik-dev
Depends: ${misc:Depends}
Description: C++/Python toolkit for developing GIS applications (doc)
 Mapnik is an OpenSource C++/Python toolkit for developing GIS
 (Geographic Information Systems) applications. At the core is a C++
 shared library providing algorithms/patterns for spatial data access and
 visualization.
 .
 Essentially a collection of geographic objects (map, layer, datasource,
 feature, geometry), the library doesn't rely on "windowing systems" and
 is intended to work in multi-threaded environments
 .
 High-level Python bindings (boost.python) facilitate rapid application
 development, targeting zope3, django, etc.
 .
 This package contains developer documentation.

=== debian/watch ===
version=3
http://download.berlios.de/mapnik/mapnik-(\d+.*)\.tar\.gz

## mapnik 0.7.1

=== SConstruct ===
--- 
+++ 
@@ -16,7 +16,7 @@
 # License along with this library; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 #
-# $Id: SConstruct 1539 2010-01-11 01:28:42Z dane $
+# $Id: SConstruct 1728 2010-03-18 22:51:14Z dane $
 
 
 import os
@@ -68,7 +68,75 @@
             name = lib
     return name
 
-if platform.uname()[4] == 'x86_64' and platform.system() == 'Linux':
+DEFAULT_LINK_PRIORITY = ['internal','other','frameworks','user','system']
+
+def sort_paths(items,priority):
+    """Sort paths such that compiling and linking will globally prefer custom or local libs
+    over system libraries by fixing up the order libs are passed to gcc and the linker.
+    
+    Ideally preference could be by-target instead of global, but our SCons implementation
+    is not currently utilizing different SCons build env()'s as we should.
+    
+    Overally the current approach within these scripts is to prepend paths of preference
+    and append all others, but this does not give enough control (particularly due to the
+    approach of assuming /usr/LIBSCHEMA and letting paths be parsed and added by pkg-config).
+    
+    In effect /usr/lib is likely to come before /usr/local/lib which makes linking against
+    custom built icu or boost impossible when those libraries are available in both places.
+    
+    Sorting using a priority list allows this to be controlled, and fine tuned.
+    """
+    
+    new = []
+    path_types = {'internal':[],'other':[],'frameworks':[],'user':[],'system':[]}
+    # parse types of paths into logical/meaningful groups
+    # based on commonly encountered lib directories on linux and osx
+    for i in items:
+        # internal paths for code kept inside
+        # the mapnik sources
+        if i.startswith('#'):
+            path_types['internal'].append(i)
+        # Mac OS X user installed frameworks
+        elif '/Library/Frameworks' in i:
+            path_types['frameworks'].append(i)
+        # various 'local' installs like /usr/local or /opt/local
+        elif 'local' in i or '/sw' in i:
+            path_types['user'].append(i)
+        # key system libs (likely others will fall into 'other')
+        elif '/usr/' in i or '/System' in i or '/lib' in i:
+            path_types['system'].append(i)
+        # anything not yet matched...
+        # likely a combo of rare system lib paths and
+        # very custom user paths that should ideally be
+        # in 'user'
+        else:
+            path_types['other'].append(i)
+    # build up new list based on priority list
+    for path in priority:
+        if path_types.has_key(path):
+            dirs = path_types[path]
+            new.extend(dirs)
+            path_types.pop(path)
+        else:
+            color_print(1,'\nSorry, "%s" is NOT a valid value for option "LINK_PRIORITY": values include: %s' % (path,','.join(path_types.keys())))
+            color_print(1,'\tinternal: the local directory of the Mapnik sources (prefix #) (eg. used to link internal agg)')
+            color_print(1,'\tframeworks: on osx the /Library/Frameworks directory')
+            color_print(1,'\tuser: any path with "local" or "/sw" inside it')
+            color_print(1,'\tsystem: any path not yet matched with "/usr/","/lib", or "/System" (osx) inside it')
+            color_print(1,'\tother: any paths you specified not matched by criteria used to parse the others')
+            color_print(1,'\tother: any paths you specified not matched by criteria used to parse the others')
+            color_print(1,'The Default priority is: %s' % ','.join(DEFAULT_LINK_PRIORITY))
+            color_print(1,'Any priority groups not listed will be appended to the list at the end')
+            Exit(1)
+    # append remaining paths potentially not requested
+    # by any custom priority list defined by user
+    for k,v in path_types.items():
+        new.extend(v)
+    return new
+
+if platform.dist()[0] in ('Ubuntu','debian'):
+    LIBDIR_SCHEMA='lib'
+elif platform.uname()[4] == 'x86_64' and platform.system() == 'Linux':
     LIBDIR_SCHEMA='lib64' 
 elif platform.uname()[4] == 'ppc64':
     LIBDIR_SCHEMA='lib64'
@@ -110,6 +178,8 @@
 
 # local file to hold custom user configuration variables
 SCONS_LOCAL_CONFIG = 'config.py'
+# build log
+SCONS_LOCAL_LOG = 'config.log'
 # local pickled file to cache configured environment
 SCONS_CONFIGURE_CACHE = 'config.cache'
 # directory SCons uses to stash build tests
@@ -158,6 +228,8 @@
     ('CONFIG', "The path to the python file in which to save user configuration options. Currently : '%s'" % SCONS_LOCAL_CONFIG,SCONS_LOCAL_CONFIG),
     BoolVariable('USE_CONFIG', "Use SCons user '%s' file (will also write variables after successful configuration)", 'True'),
     BoolVariable('FAST', "Make scons faster at the cost of less precise dependency tracking", 'False'),
+    BoolVariable('PRIORITIZE_LINKING', 'Sort list of lib and inc directories to ensure preferencial compiling and linking (useful when duplicate libs)', 'True'),
+    ('LINK_PRIORITY','Priority list in which to sort library and include paths (default order is internal, other, frameworks, user, then system - see source of `sort_paths` function for more detail)',','.join(DEFAULT_LINK_PRIORITY)),    
     
     # Install Variables
     ('PREFIX', 'The install path "prefix"', '/usr/local'),
@@ -168,46 +240,3 @@
     # default is '/usr/include', see FindBoost method below
     ('BOOST_INCLUDES', 'Search path for boost include files', '',False),
     # default is '/usr/' + LIBDIR_SCHEMA, see FindBoost method below
-    ('BOOST_LIBS', 'Search path for boost library files', '',False),
-    ('BOOST_TOOLKIT','Specify boost toolkit, e.g., gcc41.','',False),
-    ('BOOST_ABI', 'Specify boost ABI, e.g., d.','',False),
-    ('BOOST_VERSION','Specify boost version, e.g., 1_35.','',False),
-    ('BOOST_PYTHON_LIB','Specify library name or full path to boost_python lib (e.g. "boost_python-py26" or "/usr/lib/libboost_python.dylib")',''),
-    
-    # Variables for required dependencies
-    ('FREETYPE_CONFIG', 'The path to the freetype-config executable.', 'freetype-config'),
-    ('XML2_CONFIG', 'The path to the xml2-config executable.', 'xml2-config'),
-    PathVariable('ICU_INCLUDES', 'Search path for ICU include files', '/usr/include', PathVariable.PathAccept),
-    PathVariable('ICU_LIBS','Search path for ICU include files','/usr/' + LIBDIR_SCHEMA, PathVariable.PathAccept),
-    ('ICU_LIB_NAME', 'The library name for icu (such as icuuc, sicuuc, or icucore)', 'icuuc'),
-    PathVariable('PNG_INCLUDES', 'Search path for libpng include files', '/usr/include', PathVariable.PathAccept),
-    PathVariable('PNG_LIBS','Search path for libpng include files','/usr/' + LIBDIR_SCHEMA, PathVariable.PathAccept),
-    PathVariable('JPEG_INCLUDES', 'Search path for libjpeg include files', '/usr/include', PathVariable.PathAccept),
-    PathVariable('JPEG_LIBS', 'Search path for libjpeg library files', '/usr/' + LIBDIR_SCHEMA, PathVariable.PathAccept),
-    PathVariable('TIFF_INCLUDES', 'Search path for libtiff include files', '/usr/include', PathVariable.PathAccept),
-    PathVariable('TIFF_LIBS', 'Search path for libtiff library files', '/usr/' + LIBDIR_SCHEMA, PathVariable.PathAccept),
-    PathVariable('PROJ_INCLUDES', 'Search path for PROJ.4 include files', '/usr/local/include', PathVariable.PathAccept),
-    PathVariable('PROJ_LIBS', 'Search path for PROJ.4 library files', '/usr/local/' + LIBDIR_SCHEMA, PathVariable.PathAccept),
-    ('PKG_CONFIG_PATH', 'Use this path to point pkg-config to .pc files instead of the PKG_CONFIG_PATH environment setting',''),
-    
-    # Variables affecting rendering back-ends
-    BoolVariable('INTERNAL_LIBAGG', 'Use provided libagg', 'True'),
-    
-    # Variables for optional dependencies
-    # Note: cairo, cairomm, and pycairo all optional but configured automatically through pkg-config
-    # Therefore, we use a single boolean for whether to attempt to build cairo support.
-    BoolVariable('CAIRO', 'Attempt to build with Cairo rendering support', 'True'),
-    ('GDAL_CONFIG', 'The path to the gdal-config executable for finding gdal and ogr details.', 'gdal-config'),
-    ('PG_CONFIG', 'The path to the pg_config executable.', 'pg_config'),
-    PathVariable('OCCI_INCLUDES', 'Search path for OCCI include files', '/usr/lib/oracle/10.2.0.3/client/include', PathVariable.PathAccept),
-    PathVariable('OCCI_LIBS', 'Search path for OCCI library files', '/usr/lib/oracle/10.2.0.3/client/'+ LIBDIR_SCHEMA, PathVariable.PathAccept),
-    PathVariable('SQLITE_INCLUDES', 'Search path for SQLITE include files', '/usr/include/', PathVariable.PathAccept),
-    PathVariable('SQLITE_LIBS', 'Search path for SQLITE library files', '/usr/' + LIBDIR_SCHEMA, PathVariable.PathAccept),
-    
-    # Other variables
-    BoolVariable('SHAPE_MEMORY_MAPPED_FILE', 'Utilize memory-mapped files in Shapefile Plugin (higher memory usage, better performance)', 'True'),
-    ('SYSTEM_FONTS','Provide location for python bindings to register fonts (if given aborts installation of bundled DejaVu fonts)',''),
-    ('LIB_DIR_NAME','Name to use for the "lib" folder where fonts and plugins are installed','/mapnik/'),
-    PathVariable('PYTHON','Full path to Python executable used to build bindings', sys.executable),
-    BoolVariable('FRAMEWORK_PYTHON', 'Link against Framework Python on Mac OS X', 'True'),
-    ('FRAMEWORK_SEARCH_PATH','Custom framework search path on Mac OS X', ''),

=== debian/changelog ===
mapnik (0.7.1-6) unstable; urgency=low

  * Get rid of obsolete libjpeg62 dependencies.
    (closes: #629970)
  * Added me to Uploaders to avoid inappropriate NMUing.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Mon, 25 Jul 2011 14:14:28 +0200

mapnik (0.7.1-5) unstable; urgency=low

  * Correctly trap errors in debian/rules, thanks to Jakub Wilk
    (Closes: #625667)

 -- David Paleino <dapal@debian.org>  Thu, 05 May 2011 09:27:24 +0200

mapnik (0.7.1-4) unstable; urgency=low

  * 04-port_to_new_boost.patch fixes FTBFS with newer Boost::Filesystem,
    backported from upstream, thanks to Dane Springmeyer (Closes: #624934)
  * Standards-Version bump to 3.9.2, no changes needed

 -- David Paleino <dapal@debian.org>  Tue, 03 May 2011 11:04:48 +0200

mapnik (0.7.1-3) unstable; urgency=low

  * Compile using internal copy of libagg. (Closes: #603470)

 -- David Paleino <dapal@debian.org>  Fri, 19 Nov 2010 12:14:44 +0100

mapnik (0.7.1-2) unstable; urgency=low

  * debian/patches/03-fix_ImportError_mips.patch added, fixes
    un-importability on mips{,-el} due to a wrong import. Thanks
    Jakub Wilk (Closes: #599330)

 -- David Paleino <dapal@debian.org>  Sat, 09 Oct 2010 16:25:18 +0200

mapnik (0.7.1-1) unstable; urgency=low

  * New upstream version
  * debian/patches/:
    - 00-fix_amd64_libdir.patch removed, exception for Debian/Ubuntu
      added in upstream code
    - 02-fix_FTBFS_binutils-gold.patch refreshed to apply to the new
      code
    - 03-fix_typo.patch removed, merged upstream

 -- David Paleino <dapal@debian.org>  Tue, 30 Mar 2010 07:28:55 +0200

=== debian/control ===
--- 
+++ 
@@ -1,23 +1,22 @@
 Source: mapnik
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
+Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: Debian OpenStreetMap Team <pkg-osm-maint@lists.alioth.debian.org>,
- David Paleino <dapal@debian.org>
+ David Paleino <dapal@debian.org>, Francesco Paolo Lovergine <frankie@debian.org>
 Build-Depends:
  scons,
  python-support (>= 0.90.0~),
  debhelper (>= 7.0.50~),
  python-all-dev,
- libboost-thread1.40-dev,
- libboost-filesystem1.40-dev,
- libboost-regex1.40-dev,
- libboost-python1.40-dev,
- libboost-system1.40-dev,
- libboost-iostreams1.40-dev,
- libboost-program-options1.40-dev,
+ libboost-thread-dev,
+ libboost-filesystem-dev,
+ libboost-regex-dev,
+ libboost-python-dev,
+ libboost-system-dev,
+ libboost-iostreams-dev,
+ libboost-program-options-dev,
  libpng12-dev,
- libjpeg62-dev,
+ libjpeg-dev,
  libtiff4-dev,
  zlib1g-dev,
  libfreetype6-dev,
@@ -27,7 +26,6 @@
  libfribidi-dev,
  libgdal1-dev,
  libxml2-dev,
- libagg-dev,
  libicu-dev,
  libcairo2-dev,
  libcairomm-1.0-dev,
@@ -36,7 +34,7 @@
  libcurl4-gnutls-dev,
  libsigc++-2.0-dev,
  python-epydoc
-Standards-Version: 3.8.4
+Standards-Version: 3.9.2
 Section: libs
 XS-Python-Version: >= 2.5
 Homepage: http://www.mapnik.org/
@@ -72,14 +70,14 @@
  ${misc:Depends},
  libmapnik0.7 (= ${binary:Version}),
  libc6-dev | libc-dev,
- libboost-thread1.40-dev,
- libboost-filesystem1.40-dev,
- libboost-regex1.40-dev,
- libboost-python1.40-dev,
- libboost-system1.40-dev,
- libboost-iostreams1.40-dev,
+ libboost-thread-dev,
+ libboost-filesystem-dev,
+ libboost-regex-dev,
+ libboost-python-dev,
+ libboost-system-dev,
+ libboost-iostreams-dev,
  libpng12-dev,
- libjpeg62-dev,
+ libjpeg-dev,
  libtiff4-dev,
  zlib1g-dev,
  libfreetype6-dev,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# scons flags
SCONS_FLAGS := INPUT_PLUGINS=raster,sqlite,postgis,ogr,shape,osm,gdal,kismet
SCONS_FLAGS += PROJ_INCLUDES=/usr/include PROJ_LIBS=/usr/lib
SCONS_FLAGS += SYSTEM_FONTS=/usr/share/fonts/truetype/ttf-dejavu
SCONS_FLAGS += XMLPARSER=libxml2
SCONS_FLAGS += DESTDIR=$(CURDIR)/debian/tmp
SCONS_FLAGS += PREFIX=/usr LIB_DIR_NAME=/mapnik/0.7

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	export CFLAGS += -O0
else
	export CFLAGS += -O2
endif

override_dh_auto_configure:
	scons $(SCONS_FLAGS) CCFLAGS="$(CFLAGS)" configure
	dh_auto_configure

override_dh_auto_build:
	set -e; \
	for py in $(shell pyversions -r); do \
		scons $(SCONS_FLAGS) PYTHON=/usr/bin/$$py ; \
	done

	dh_auto_build

override_dh_prep:
	dh_prep -Xdebian/tmp

override_dh_install:
	dh_install
	find $(CURDIR)/debian/ -name "modserver.py" | xargs chmod -x

	# build Python API documentation
	# and trick epydoc into loading the shlib too
	-ln -s ../_mapnik.so bindings/python/mapnik/
	-( cd docs/epydoc_config ; \
	LD_LIBRARY_PATH=$(CURDIR)/debian/libmapnik0.7/usr/lib/ ./build_epydoc.sh )
	rm -rf bindings/python/mapnik/_mapnik.so
	dh_install -pmapnik-doc docs/api_docs/python /usr/share/doc/mapnik-doc/

override_dh_auto_clean:
	scons --clean $(SCONS_FLAGS)
	find -name '*.pyc' -exec rm -f {} \;
	find -name '.sconsign*' -exec rm -f {} \;
	find -name '*.o' -exec rm -f {} \;
	rm -rf .sconf_temp config.log bindings/python/mapnik/paths.py \
		utils/shapeindex/shapeindex config.py config.cache \
		docs/api_docs/python/*

	dh_auto_clean

override_dh_installexamples:
	dh_installexamples -Xdata/new
	find $(CURDIR)/debian/ -name "*.png" | xargs -r chmod -x

%:
#	dh_installexamples -Xdata/new
#	dh_install --sourcedir=debian/tmp
	dh $@
